#ifndef _PROTOCOL_H
#define _PROTOCOL_H

#include <stdio.h>
#include <stdbool.h>
#include <stm32f10x.h>


#define SoftAp_Mode    0x01
#define AirLink_Mode   0x02

#define MAX_P0_LEN			128 	 		 //ûP0󳤶
#define MAX_PACKAGE_LEN		(MAX_P0_LEN*2) 	 //ݰ󳤶,ûP0󳤶
#define MAX_RINGBUFFER_LEN	MAX_PACKAGE_LEN  //λ󳤶
#define Max_UartBuf         MAX_PACKAGE_LEN


#define PROTOCOL_DEBUG

#define Send_MaxTime   200
#define Send_MaxNum    2

#define		PRO_VER																"00000004"
#define		P0_VER																"00000004"
#define		HARD_VER															"00000001"
#define		SOFT_VER															"00000001"
#define		PRODUCT_KEY															"6f3074fe43894547a4f1314bd7e3ae0b"


//豸ͨ
__packed	typedef struct
{
//    uint8_t						Package_Flag;    				 //жǷյһĴݰ
//    uint8_t						UART_Flag1;
//    uint8_t						UART_Flag2;
//    uint16_t 						UART_Count;								//ڻݳ
//    uint8_t						UART_Cmd_len;							//ָ
//    uint8_t 						UART_Buf[Max_UartBuf]; 		//ڻ
    uint8_t             			Message_Buf[Max_UartBuf]; //յָBuf
    uint8_t             			Message_Len;	            //Ϣ

} UART_HandleTypeDef;

//Эָ
typedef enum
{
    Pro_W2D_GetDeviceInfo_Cmd 					= 0x01,
    Pro_D2W__GetDeviceInfo_Ack_Cmd				= 0x02,

    Pro_W2D_P0_Cmd 								= 0x03,
    Pro_D2W_P0_Ack_Cmd							= 0x04,

    Pro_D2W_P0_Cmd 								= 0x05,
    Pro_W2D_P0_Ack_Cmd							= 0x06,

    Pro_W2D_Heartbeat_Cmd 						= 0x07,
    Pro_D2W_heartbeatAck_Cmd					= 0x08,

    Pro_D2W_ControlWifi_Config_Cmd 				= 0x09,
    Pro_W2D_ControlWifi_Config_Ack_Cmd			= 0x0A,

    Pro_D2W_ResetWifi_Cmd 						= 0x0B,
    Pro_W2D_ResetWifi_Ack_Cmd					= 0x0C,

    Pro_W2D_ReportWifiStatus_Cmd 				= 0x0D,
    Pro_D2W_ReportWifiStatus_Ack_Cmd			= 0x0E,

    Pro_W2D_ReportMCUReset_Cmd 					= 0x0F,
    Pro_D2W_ReportMCUReset_Ack_Cmd				= 0x10,

    Pro_W2D_ErrorPackage_Cmd 					= 0x11,
    Pro_D2W_ErrorPackage_Ack_Cmd				= 0x12,
	
	/*3.10*/
	

} Pro_CmdTypeDef;

/******************************************************
* ACK ظ
* SendTime
********************************************************/
__packed	typedef struct
{
    uint32_t        SendTime;
    uint8_t			SendNum;
    uint8_t			Flag;
    uint8_t			Cmd_Buff[Max_UartBuf];
} Pro_Wait_AckTypeDef;


/******************************************************
* ЭĹò
********************************************************/
__packed	typedef struct
{
    uint8_t							Head[2];
    uint16_t						Len;
    uint8_t							Cmd;
    uint8_t							SN;
    uint8_t							Flags[2];

} Pro_HeadPartTypeDef;

/******************************************************
* 4.1  WiFiģ豸Ϣ
********************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef  					Pro_HeadPart;
    uint8_t									Pro_ver[8];
    uint8_t									P0_ver[8];
    uint8_t									Hard_ver[8];
    uint8_t									Soft_ver[8];
    uint8_t									Product_Key[32];
    uint16_t								Binable_Time;
    uint8_t									Sum;

} Pro_M2W_ReturnInfoTypeDef;

/*****************************************************
*       ͨackȿԸô֡            *
******************************************************
* 4.2 	WiFiģ豸MCU
* 4.4 	豸MCUWiFiģ
* 4.6 	WiFiģMCU
* 4.9 	Wifiģظ
* 4.10  豸MCUظ
******************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef    	Pro_HeadPart;
    uint8_t					Sum;
} Pro_CommonCmdTypeDef;


/******************************************************
* 4.3 豸MCUͨWiFiģģʽ
********************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef  		Pro_HeadPart;
    uint8_t                 	Config_Method;
    uint8_t						Sum;
} Pro_D2W_ConfigWifiTypeDef;


/*****************************************************
*WiFiģʽ궨
******************************************************/
#define 		Wifi_SoftAPMode       			(uint8_t)(1<<0)    //ǷSoftAP ģʽ0:رգ1
#define 		Wifi_StationMode      	    	(uint8_t)(1<<1)    //ǷStationģʽ0:رգ1
#define 		Wifi_ConfigMode       		  	(uint8_t)(1<<2)    //Ƿģʽ0:رգ1
#define 		Wifi_BindingMode     			(uint8_t)(1<<3)  	 //Ƿģʽ0:رգ1
#define     	Wifi_ConnRouter             	(uint8_t)(1<<4) 	 //WiFiģǷɹӵ·0:رգ1
#define     	Wifi_ConnClouds             	(uint8_t)(1<<5)    //WiFiģǷɹӵƶˣ0:رգ1


/*****************************************************
* 4.5 WiFiģ豸MCU֪ͨWiFiģ鹤״̬ı仯
******************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef    	Pro_HeadPart;
    uint16_t                Wifi_Status;
    uint8_t					Sum;
} Pro_W2D_WifiStatusTypeDef;

/*****************************************************
* ǷϢ֪ͨöб
******************************************************/
typedef enum
{
    Error_AckSum = 0x01,      //Уʹ
    Error_Cmd 	 = 0x02,	  //ʶ
    Error_Other  = 0x03,      //
} Error_PacketsTypeDef;


/*****************************************************
* 4.7 ǷϢ֪ͨ
******************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef  		Pro_HeadPart;
    Error_PacketsTypeDef		Error_Packets;
    uint8_t						Sum;
} Pro_ErrorCmdTypeDef;


/*****************************************************
* P0 command б
******************************************************/
typedef enum
{
    P0_W2D_Control_Devce_Action 		= 0x01,
    P0_W2D_ReadDevStatus_Action 		= 0x02,
    P0_D2W_ReadDevStatus_Action_ACK 	= 0x03,
    P0_D2W_ReportDevStatus_Action   	= 0X04,

} P0_ActionTypeDef;


/******************************************************
* P0ָĹ
********************************************************/
__packed	typedef struct
{
    Pro_HeadPartTypeDef  		Pro_HeadPart;
    P0_ActionTypeDef        	Action;
} Pro_HeadPartP0CmdTypeDef;

short	exchangeBytes(short	value);
uint8_t CheckSum( uint8_t *buf, int packLen );
void GizWits_init(uint8_t P0_Len);
void GizWits_D2WResetCmd(void);
void GizWits_D2WConfigCmd(uint8_t WiFi_Mode);
//void GizWits_DevStatusUpgrade(uint8_t *P0_Buff, uint32_t Time, uint8_t flag);
void GizWits_DevStatusUpgrade(uint8_t *P0_Buff, uint32_t Time, uint8_t flag , uint8_t netFlag);
void GizWits_WiFiStatueHandle(uint16_t wifiStatue);
u8 GizWits_MessageHandle(u8 * Message_Buf, u8 Length_buf);

#endif /*_PROTOCOL_H*/
